# Don't generate any debuginfo packages
%global debug_package %{nil}
%define prefix /usr

Summary: Ligo low-latency data distribution server initialization
Name: llldd
Version: 0.5.4
Release: 1
License: GPL
Group: Ligo daswg
URL: https://wiki.ligo.org/daswg/LowLatency
Source0: %{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: 	gds-services gds-devel virgoApp-Fd >= 6.9.2
Requires:  gds-services >= 2.15.7

%define llservice llldd

%description
Init files for Ligo low-latency data distribution system

%package xfer
Version: 0.5.4
Summary: Ligo low-latency transfer untility
Group: LIGO daswg
URL: https://wiki.ligo.org/daswg/LowLatency
Requires: gds-services >= 2.15.7 virgoApp-Fd >= 6.9.2

%description xfer
Init files for Ligo low-latency data transfer utility

%package ganglia
Version: 0.5.4
Summary: Ligo low-latency data ganglia plugin
Group: LIGO daswg
URL: https://wiki.ligo.org/daswg/LowLatency
BuildRequires: apr-devel ganglia-devel libconfuse-devel
Requires: gds-core >= 2.15.7

%description ganglia
Ganglia plugin module and configuration for low-latency monitoring.

%package config-cit
Version: 0.5.4
Summary: Ligo Low-latency configuration for Caltech
Group: LIGO daswg
URL: https://wiki.ligo.org/daswg/LowLatency
Requires: llldd >= 0.5.4

%description config-cit
Configuration files for low latency data distribution at Caltech

%package config-lho
Version: 0.5.4
Summary: Ligo Low-latency configuration for LHO
Group: LIGO daswg
URL: https://wiki.ligo.org/daswg/LowLatency
Requires: llldd >= 0.5.4

%description config-lho
Configuration files for low latency data distribution at LHO

%package config-llo
Version: 0.5.4
Summary: Ligo Low-latency configuration for LLO
Group: LIGO daswg
URL: https://wiki.ligo.org/daswg/LowLatency
Requires: llldd >= 0.5.4

%description config-llo
Configuration files for low latency data distribution at LLO

%prep
%setup -q

%build
./configure --prefix=%{prefix} --sysconfdir=/etc --libdir=%{prefix}/%{_lib} \
            --with-user=lluser --enable-ganglia-plugin
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group lluser >/dev/null || groupadd -r lluser
getent passwd lluser >/dev/null || \
    useradd -r -g lluser -d %{_datadir}/%{name} -s /sbin/nologin \
    -c "Low latency data distribution infrastructure" lluser
exit 0

%pre xfer
getent group lluser >/dev/null || groupadd -r lluser
getent passwd lluser >/dev/null || \
    useradd -r -g lluser -d %{_datadir}/%{name} -s /sbin/nologin \
    -c "Low latency data distribution infrastructure" lluser
exit 0

%post
/sbin/chkconfig --add %llservice
/sbin/chkconfig %llservice off
for f in %{llservice}/llshm_config sysconfig/%{llservice}; do
    [ -f %{_sysconfdir}/$f ] || \
	cp %{_sysconfdir}/${f}.default %{_sysconfdir}/$f
done

%post xfer
/sbin/chkconfig --add llxfer
/sbin/chkconfig llxfer off
/sbin/chkconfig --add llsend
/sbin/chkconfig llsend off
for f in %{llservice}/llsend_config %{llservice}/llxfer_config; do
    [ -f %{_sysconfdir}/$f ] || \
	cp %{_sysconfdir}/${f}.default %{_sysconfdir}/$f
done

%preun
if [ $1 -eq 0 ] ; then
    /sbin/service %llservice stop >/dev/null 2>&1
    /sbin/chkconfig --del %llservice
fi

%files
%defattr(-,root,root,-)
# %doc
%{_sysconfdir}/init.d/%{llservice}
%{_sysconfdir}/sysconfig/%{llservice}.default
%{_sysconfdir}/%{llservice}/llshm_config.default

%preun xfer
if [ $1 -eq 0 ] ; then
    /sbin/service llxfer stop >/dev/null 2>&1
    /sbin/chkconfig --del llxfer
fi

%files xfer
%{_sysconfdir}/init.d/llxfer
%{_sysconfdir}/init.d/llsend

%{_sysconfdir}/%{llservice}/llxfer_config.default
%{_sysconfdir}/%{llservice}/llsend_config.default
%{_sysconfdir}/%{llservice}/*.cfg
%{_prefix}/bin/*

%files ganglia
%{_sysconfdir}/ganglia/conf.d/*
%{prefix}/%{_lib}/ganglia/*


%files config-cit
%{_sysconfdir}/%{llservice}/llshm_config.cit
%{_sysconfdir}/%{llservice}/llxfer_config.cit
%{_sysconfdir}/%{llservice}/llsend_config.cit
%{_sysconfdir}/sysconfig/%{llservice}.cit
%{_sysconfdir}/sysconfig/%{llservice}.cit.ldas-grid

%post config-cit
for srvc in llshm llxfer llsend; do
    [ -f %{_sysconfdir}/%{llservice}/${srvc}_config ] || \
    cp  %{_sysconfdir}/%{llservice}/${srvc}_config.cit \
	%{_sysconfdir}/%{llservice}/${srvc}_config
done
if [ ! -f %{_sysconfdir}/sysconfig/%{llservice} ]; then
    if [ `uname -n` = "ldas-grid" ]; then
	cp %{_sysconfdir}/sysconfig/%{llservice}.cit.ldas-grid \
	   %{_sysconfdir}/sysconfig/%{llservice}
    else
	cp %{_sysconfdir}/sysconfig/%{llservice}.cit \
	   %{_sysconfdir}/sysconfig/%{llservice}
    fi
fi

%files config-lho
%{_sysconfdir}/%{llservice}/llshm_config.lho
%{_sysconfdir}/%{llservice}/llxfer_config.lho
%{_sysconfdir}/%{llservice}/llsend_config.lho
%{_sysconfdir}/sysconfig/%{llservice}.lho

%post config-lho
for srvc in llshm llxfer llsend; do
    [ -f %{_sysconfdir}/%{llservice}/${srvc}_config ] || \
    cp  %{_sysconfdir}/%{llservice}/${srvc}_config.lho \
	%{_sysconfdir}/%{llservice}/${srvc}_config
done
[ -f %{_sysconfdir}/sysconfig/%{llservice} ] || \
cp %{_sysconfdir}/sysconfig/%{llservice}.lho \
   %{_sysconfdir}/sysconfig/%{llservice}

%files config-llo
%{_sysconfdir}/%{llservice}/llshm_config.llo
%{_sysconfdir}/%{llservice}/llxfer_config.llo
%{_sysconfdir}/%{llservice}/llsend_config.llo
%{_sysconfdir}/sysconfig/%{llservice}.llo

%post config-llo
for srvc in llshm llxfer llsend; do
    [ -f %{_sysconfdir}/%{llservice}/${srvc}_config ] || \
    cp  %{_sysconfdir}/%{llservice}/${srvc}_config.llo \
	%{_sysconfdir}/%{llservice}/${srvc}_config
done
[ -f %{_sysconfdir}/sysconfig/%{llservice} ] || \
cp %{_sysconfdir}/sysconfig/%{llservice}.llo \
   %{_sysconfdir}/sysconfig/%{llservice}


%changelog
* Tue Jan 10 2012  <ed.maros@ligo.org> - 
- Add.

* Mon Dec 19 2011  <john.zweizig@ligo.org> - 
- Initial build.
